var player = null;
var transfer = false;
var geo_watch_id = false;
var last_geo_watch = 0;

$(document).ready(function(){   
    player = new PlayerController();
    //player.activateLogger(true);
    $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
    player.init("","WEB");
    //player.setTrimPath(false); // DEBUG ONLY
    //player.init("http://local/data/","WEB"); // DEBUG ONLY
});

function onPlayerDataLoaded(){
  try{
    if(player.playlist.conditional.data){
        activateConditionalAgents(true);
    }else{
        activateConditionalAgents(false);
    }
  }catch(e){
    console.log("Unable to start conditional controller");
  }
}

function activateConditionalAgents(activate){
    if(activate){
        //GEO
        if(!geo_watch_id){
            last_geo_watch = (new Date()).getTime();
            geo_watch_id = navigator.geolocation.watchPosition(onGeoUpdate, onGeoError, { timeout: 15000, enableHighAccuracy: true });
        }
    }else{
        navigator.geolocation.clearWatch(geo_watch_id);
    }
}

function onGeoUpdate(position){
  if((new Date()).getTime() - last_geo_watch > 5000){  
    last_geo_watch = (new Date()).getTime();
    var latitude = position.coords.latitude;
    var longitude = position.coords.longitude;
    var altitude = position.coords.altitude;
    var accuracy = position.coords.accuracy;
    var altitudeAccuracy = position.coords.altitudeAccuracy;
    var heading = position.coords.heading;

    if(player.playlist.conditional){
        var timestamp = parseInt(new Date().getTime()/1000);

        // Write latitude Condition
        var lat = {
            'id': 1,
            'filename': "lat.xml",
            'mdate': 0,
            'tstamp': timestamp,
            'version': "1.0",
            'status': "ok",
            'value': latitude
        };
        player.playlist.conditional.onNewConditionValue(lat,false,true);

        // Write longitude Condition
        var lon = {
            'id': 2,
            'filename': "lon.xml",
            'mdate': 0,
            'tstamp': timestamp,
            'version': "1.0",
            'status': "ok",
            'value': longitude
        };
        player.playlist.conditional.onNewConditionValue(lon,false,true);
        // Write heading Condition
        var head = {
            'id': 20,
            'filename': "heading.xml",
            'mdate': 0,
            'tstamp': timestamp,
            'version': "1.0",
            'status': "ok",
            'value': heading
        };
        player.playlist.conditional.onNewConditionValue(head,false,true);
    }
  }
  
}

function onGeoError(event){
    console.log("GEO Error ... could not get position");
}
